/*
 * send.c: a simple program that sends a message, and prints the reply
 *
 * $Id: send.c 132 2011-07-01 14:35:01Z meaton $
 */

#include <assert.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "srr.h"

int main(int argc, char* argv[])
{
	int		opt, len;
	int		pid = 0;
	char*	name = 0;
	char	smsg[BUFSIZ] = "";
	char	rmsg[BUFSIZ] = "";

	sprintf(smsg, "msg from %d", getpid());

	while((opt = getopt(argc, argv, "p:n:")) != -1)
	{
		switch(opt)
		{
		case 'p':
			pid = atoi(optarg);
			break;

		case 'n':
			name = optarg;
			break;

		default:
			exit(1);
		}
	}

	if(SrrReg() == -1)
	{
		printf("send %d: InitSrr() failed: [%d] %s\n",
			getpid(), errno, strerror(errno));

		exit(1);
	}

	if(name)
	{
		if((pid = qnx_name_locate(0, name, 0, 0)) == -1)
		{
			printf("send %d: qnx_name_locate() failed: [%d] %s\n",
				getpid(), errno, strerror(errno));
			exit(1);
		}
	}

	printf("send %d: sending: \"%s\"\n", getpid(), smsg);

	if((len = SrrSend(pid, smsg, rmsg, strlen(smsg)+1, BUFSIZ)) == -1)
	{
		printf("send %d: Send() failed: [%d] %s\n",
			getpid(), errno, strerror(errno));
		exit(1);
	}

	printf("send %d: received len %d: \"%s\"\n", getpid(), len, rmsg);

	return 0;
}

